classification
Title: test_ctypes failure on AIX 5.3
Type: behavior Stage: needs patch
Components: ctypes Versions: Python 2.6
process
Status: closed Resolution:
Dependencies: Superseder:
Assigned To: theller Nosy List: mallayya, sable, theller
Priority: normal Keywords: patch

Created on 2010-01-08 07:02 by mallayya, last changed 2010-09-14 13:07 by sable. This issue is now closed.

Files
File name Uploaded Description Edit
ctype-tests.txt mallayya, 2010-01-08 07:02 test cases result
bitfield.patch mallayya, 2010-01-08 15:21
Messages (2)
msg97395 - (view) Author: sangamesh (mallayya) Date: 2010-01-08 07:02
I built the python-2.6.2 with the latest libffi-3.0.9 in AIX 5.3 using xlc compiler.
When i try to run the ctypes test cases, two failures are seen in test_bitfields.

test_ints (ctypes.test.test_bitfields.C_Test) ... FAIL
test_shorts (ctypes.test.test_bitfields.C_Test) ... FAIL

It seems that interpreting type c_int and c_short is wrong in bit field for AIX. If i change the type c_int and c_short 
to c_unit and c_ushort of class "BITS(Structure)" in file test_bitfields.py then no failures are seen and all the test 
cases got passed

This issue is common for both 32 and 64-bit versions

Attaching the complete test case result for reference.
msg97625 - (view) Author: sangamesh (mallayya) Date: 2010-01-12 08:50
These failures are specific to xlc compiler
In xlc signed bit fields will be mapped to unsigned by default as opposed to gcc where the value stored in the bit field is of type declared. 
so the the value returned by "func(byref(b), name)"  positive in some cases as it expected to be of type declared.

Their  is an xlc compiler option  "-qbitfields=signed" to make the bit fields of type signed.
After this all the ctypes test cases got passed.
History
Date User Action Args
2010-09-14 13:07:11sablesetnosy: + sable
2010-01-12 08:50:54mallayyasetstatus: open -> closed

messages: + msg97625
2010-01-08 15:21:55mallayyasetfiles: + bitfield.patch
keywords: + patch
2010-01-08 14:47:50brian.curtinsetstage: needs patch
2010-01-08 07:02:32mallayyacreate